// Dialog definitions *****************************

#include <mywin.h>

#include <stdlib.h>
#include <stdio.h>

#include <stringc.h>
#include <dialog.h>
#include <app.h>

Dialog *Dlg;

BOOL PASCAL DialogHandler (HWND hDlg, UINT uMessage,
								WPARAM wParam, LPARAM lParam);

Dialog::Dialog(Object *Parent ,int Id, char *Sect) : Object(Parent)
{
	lpProcDialog = DialogHandler;
	ID=Id;
	hWnd=0;
	Section=Sect;
}

Dialog::~Dialog()
{
	if (hWnd)
	{
		if (IsModal) ::EndDialog(hWnd,IDCANCEL);
		else DestroyWindow(hWnd); //destroy modeless dialog
	}
}

int Dialog::Execute()
{
	IsModal=TRUE;
	Dlg = this;
	return DialogBox(App::hInstance, MAKEINTRESOURCE(ID), ParentHWnd,lpProcDialog);
}

BOOL Dialog::Create()
{
	IsModal=FALSE;
	Dlg = this;
	// modeless dialog creation
	hWnd=CreateDialog(App::hInstance,
		MAKEINTRESOURCE(ID), ParentHWnd,lpProcDialog);
	return hWnd!=NULL;
}

BOOL Dialog::SetupWindow() {
	CentreDlgOnParent();
	return TRUE;
}

void Dialog::EndDialog(int) {}

void Dialog::CentreDlgOnParent()
{
	RECT rc;
	GetWindowRect(ParentHWnd,&rc);
	int x=(rc.left+rc.right)/2;
	int y=(rc.top+rc.bottom)/2;

	GetClientRect(hWnd,&rc);
	SetWindowPos(hWnd,0,
				 x - (rc.right - rc.left) / 2,
				 y - (rc.bottom - rc.top) / 2,
				 0,0,SWP_NOSIZE | SWP_NOZORDER);
}

void Dialog::KillDialog(int Value)
{
	if (Value==IDOK)
		if (!CanClose()) return;

	EndDialog(Value);
	if (IsModal) ::EndDialog(hWnd, Value);
	else
	{
		DestroyWindow(hWnd);
	}
}

void Dialog::Paint(HDC, BOOL, RECT&) {}

BOOL Dialog::ChildIDMessage(UINT id ,TMSG &Msg)
{
	return ChildMessage(GetDlgItem(hWnd,id),Msg);
}

BOOL Dialog::ChildMessage(HWND hw,TMSG &Msg)
{
	Object *Child=FirstChild();
	while (Child)
	{
		if (Child->hWnd==hw) return Child->WndProc(Msg);
		Child=NextChild(Child);
	}
	return FALSE;
}


// if breakpoint is set in this code then dialogs lose their modalness ?????

BOOL PASCAL DialogHandler (HWND hDlg, UINT uMessage,
								WPARAM wParam, LPARAM lParam)

{
	TMSG Msg={uMessage,wParam,lParam,0};
	if (Dlg->EV_FIND(Msg)) return TRUE;

	switch (uMessage)
	{

		case WM_INITDIALOG:
			Dlg->hWnd=hDlg;
			Dlg->SetupWindow();
			return TRUE;

		case WM_DESTROY:  //if main window?
			if (Dlg==App::MainWindow) PostQuitMessage(0);
			//WindowInfo::Delete(hDlg);
			Dlg->hWnd=NULL;
			return TRUE;

		case WM_PAINT:
			PAINTSTRUCT  ps;
			BeginPaint(Dlg->hWnd, (LPPAINTSTRUCT) &ps);
			Dlg->Paint(ps.hdc,ps.fErase,ps.rcPaint);
			EndPaint(Dlg->hWnd, (LPPAINTSTRUCT) &ps);
			return TRUE;

		case WM_DRAWITEM:
			return Dlg->ChildIDMessage((UINT) wParam,Msg);
		case WM_COMMAND:
			switch (wParam)
			{
				case IDOK:
				case IDCANCEL:
					Dlg->KillDialog(wParam);
					return (TRUE);

				default:
					return Dlg->ChildMessage((HWND) LOWORD(lParam),Msg);
			}    // switch (wParam)
		}     // switch (uMessage)

	return FALSE;
}

