#include <fname.h>
#include <stringc.h>
#include <wstring.h>
#include <filedlg.h>
#include <commdlg.h>

int OpenFileDlg(HWND hWnd, const wchar_t *Filters, int *FiltIndex,
				String &Name, int size, String Title)
{
	FName F(Name);
	String fname = F.GetName();
	String Dir;
	F.GetDir(Dir);

	WS wtitle = Title;
	wchar_t *wdir = (WS(Dir)).dup ();
	wchar_t *wfile = new wchar_t [1000];
	wcscpy (wfile, WS (fname));

	OPENFILENAME O;

	O.lStructSize = sizeof (O);
	O.hwndOwner = hWnd;
	O.lpstrFilter = Filters;
	O.nFilterIndex = (FiltIndex ? *FiltIndex : 0);
	O.lpstrFileTitle = NULL;
	O.lpstrTitle = wtitle;
	O.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
	O.lpstrDefExt=NULL;
	O.lpstrInitialDir = wdir;
	O.lpstrFile = wfile;
	O.nMaxFile = 1000/2;

	int ret= GetOpenFileName(&O);

	if (ret)
	{
		Name = StringFromWS (wfile);
		if (FiltIndex) *FiltIndex=O.nFilterIndex;
	}

	delete [] wdir;
	delete [] wfile;
	return ret;
}

int SaveFileDlg(HWND hWnd, const wchar_t *Filters, int *FiltIndex,
				String &Name, int size, String Title)
{
	FName F(Name);
	String fname = F.GetName();
	String Dir;
	F.GetDir(Dir);

	WS wtitle = Title;
	wchar_t *wdir = (WS(Dir)).dup ();
	wchar_t *wfile = new wchar_t [1000];

	wcscpy (wfile, WS (fname));

	OPENFILENAME O;

	O.lStructSize = sizeof (O);
	O.hwndOwner = hWnd;
	O.lpstrFilter = Filters;
	O.nFilterIndex = (FiltIndex ? *FiltIndex : 0);
	O.lpstrFileTitle = NULL;
	O.lpstrTitle = wtitle;
	O.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	O.lpstrDefExt=NULL;
	O.lpstrInitialDir = wdir;
	O.lpstrFile = wfile;
	O.nMaxFile = 1000/2;

	int ret = GetSaveFileName(&O);

	if (ret)
	{
		Name = StringFromWS (wfile);
		if (FiltIndex) *FiltIndex=O.nFilterIndex;
	}

	delete [] wdir;
	delete [] wfile;
	return ret;
}

int SaveDirDlg (HWND hWnd, String &Dir, int size, String Title, String Prompt)
{
	wchar_t *wdir = (WS(Dir)).dup ();

	WS wtitle = Title;
	wchar_t *wfile = new wchar_t [1000];
	wcscpy (wfile, WS (Dir << "\\" << Prompt));

	OPENFILENAME O;

	O.lStructSize = sizeof (O);
	O.hwndOwner = hWnd;
	O.lpstrFilter = NULL;
	O.lpstrFileTitle = NULL;
	O.lpstrTitle = wtitle;
	O.Flags = OFN_CREATEPROMPT | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
	O.lpstrDefExt = NULL;
	O.lpstrInitialDir = wdir;
	O.lpstrFile = wfile;
	O.nMaxFile = 1000/2;

	int ret= GetOpenFileName(&O);

	if (ret)
	{
		char *temp = StringFromWS (wfile);
		String temp1 (1000);
		strncpy (temp1, temp, O.nFileOffset - 1);
		Dir = temp1;
		delete temp;
	}

	delete [] wdir;
	delete [] wfile;
	return ret;
}
