#include <string.h>
#include <screenstring.h>

int ScreenString::MaxWidth = 1;
int ScreenString::SpaceWidth = 1;
int ScreenString::MaxLines = 2;

String ScreenString::GetString ()
{
/*	String result = String ("");
	int word = 0;

	for (int i = 0; i < numWords (); i++)
	{
		if (word) result << ' ';
		else
			word++;
		result << words[i]->str;
	}
	return result;
*/
	return string;
}

String ScreenString::GetStringFromLine (int line)
{
	String result = String ("");
	int word = 0;

	for (int i = 0; i < numWords (); i++)
		if (words[i]->line >= line)
		{
			if (word) result << ' ';
			else
				word++;
			result << words[i]->str;
		}
	return result;
}

String ScreenString::GetStringFirstLine ()
{
	String result = String ("");
	int word = 0;

	for (int i = 0; i < numWords (); i++)
	{
		if (words[i]->line == 0)
		{
			if (word) result << ' ';
			else
				word++;
			result << words[i]->str;
		}
	}

	return result;
}

ScreenString ScreenString::GetScreenStringLine (int line)
{
	String string;
	ScreenString result (string, 0, 0);
	int word = 0;

	int newx = 0, newy = 0;

	for (int i = 0; i < numWords (); i++)
		if (words[i]->line == line)
		{
			if (word) string << ' ';
			else
			{
				newx = x + words [i]->x;
				newy = y + words [i]->y;
				word++;
			}
			string << words[i]->str;
		}

	result.x = newx;
	result.y = newy;
	result.SetString (string);

	return result;
}

String ScreenString::GetWord (int wx, int wy)
{
	ssw *s;

	wx -= x;
	wy -= y;

	if ((wx < 0) || (wx > dx) || (wy < 0) || (wy > dy))
		return String ("");

	for (int i = 0; i < numWords (); i++)
	{
		s = words[i];

		if ((s->x <= wx) && (s->x + s->dx >= wx) &&
			(s->y <= wy) && (s->y + s->dy >= wy)) return s->str;
	}

	return String ("");
}

void ScreenString::SetString (String &str)
{
	ssw *pss;
	int i, wx, wy, wdx, wdy;
	String word;
	char c;

	int last = str.Len () - 1;

	numLines = 0;
	wx = wy = 0;
	dx = wdx = 0;
	dy = wdy = 1;
	int wordstart = -1;

	words.Clear ();
	string = "";

	for (i = 0; i < str.Len (); i++)
	{
		c = str [i];
		
		if ((c != '\r') && (c != ' '))
		{
			word << c;
			if (wordstart == -1)
				wordstart = i;
		}

		if ((c == ' ') || (c == '\r') || (i == last))
		{
			if (word.Len ())
			{
				wdx = LineLength (word, word.Len ());
				if ((wx + wdx > MaxWidth) && (wdx <= MaxWidth))
				{
					wx = 0;
					wy++;
					numLines++;
				}
				if (dx < wx + wdx)
					dx = wx + wdx;
				if (dy < wy + wdy)
					dy = wy + wdy;

				pss = new ssw;
				pss->str = word;
				pss->x = wx;
				pss->y = wy;
				pss->dx = wdx;
				pss->dy = wdy;
				pss->pos = wordstart;
				pss->line = numLines;

				words.Add (pss);

				if (!string.Empty ())
					string << ' ';

				string << word;

				word="";
				wordstart = -1;

				if (!(i == last))
					if ((wdx > MaxWidth) || c == '\r')
					{
						wx = 0;
						wy++;
						numLines++;
					}
					else
						wx += wdx + SpaceWidth;
			}
		}
		else
		{
		}
	}
	numLines++;
	if (!(str.Len ()))
		numLines = 0;
}

int ScreenString::GetCaretX (int pos)
{
	int wpos;
	ssw *pss;
	String tword;

	int i = numWords ();

	while (i--)
	{
		pss = words [i];
		wpos = pos - pss->pos;
		if ((wpos >=0) && (wpos <= pss->str.Len ()))
		{
			tword = pss->str;
			tword [wpos] = '\0';
			return (pss->x + LineLength (tword, wpos));
		}
	}

	return x;
}

int ScreenString::GetCaretY (int pos)
{
	ssw *pss;
	int wpos;

	for (int i = 0; i < numWords (); i++)
	{
		pss = words [i];
		wpos = pos - words [i]->pos;
		if ((wpos >=0) && (wpos <= pss->str.Len ()))
			return (y + pss->y);
	}

	return y;
}

ScreenString& ScreenString::operator = (ScreenString& str)
{
	words.Clear ();
	x = str.x;
	y = str.y;
	SetString (str.GetString ());

	return *this;
}

bool ScreenString::Visible ()
{
	return ((((x >= 0) && (x <= MaxWidth)) || ((x + dx > 0) && (x + dx <= MaxWidth))) &&
			(((y >= 0) && (y <= MaxLines)) || ((y + dy > 0) && (y + dy <= MaxLines))));
}

bool ScreenString::FullyVisible ()
{
	return ((x >= 0) && (x + dx <= MaxWidth) && (y >= 0) && (y + dy <= MaxLines));
}
