#ifndef LEVEL9_SCREEN_H
#define LEVEL9_SCREEN_H

#include <screenstring.h>
#include <level9.h>

#define KEY_DELETE_CODE 257
#define KEY_BACKSPACE_CODE 258
#define KEY_UP_CODE 259
#define KEY_DOWN_CODE 260
#define KEY_LEFT_CODE 261
#define KEY_RIGHT_CODE 262
#define KEY_END_CODE 263
#define KEY_HOME_CODE 264
#define KEY_ESCAPE_CODE 265
#define KEY_CANCEL_INPUT -1
#define KEY_REPLACE_INPUT -2
#define KEY_TIMEOUT -3


char os_readchar(int millis);
int  os_getchar(int millis);

int LineLength(char*str, int n);
void MakeCaret();
void KillCaret();
void HideCaret();
void ShowCaret();
void SetCaret(int x, int y);

void DrawOneLine (int x, int y, int dx, int dy, const String &line);
void UnDrawRect (int x, int y, int dx, int dy);

//bool IsScreenStringVisible (const ScreenString &sstr);
//bool IsScreenStringFullyVisible (const ScreenString &sstr);

void PreScrollWindow ();
void PostScrollWindow ();

void PostAddScreenString ();

void Wait (int millis);

#endif
